extrn   GetStdHandle:proc
extrn   WriteFile:proc
extrn   wsprintfA:proc

.data

STD_INPUT_HANDLE        equ     -10
STD_OUTPUT_HANDLE       equ     -11
STD_ERROR_HANDLE        equ     -12

text_buff       db      500 dup (?)
console_in      dd      ?
console_out     dd      ?
bytes_read      dd      ?

.code

;
  init_console  proc
;
        push    STD_INPUT_HANDLE
        call    GetStdHandle
        or      eax, eax
        je      init_error
        mov     [console_in], eax
        push    STD_OUTPUT_HANDLE
        call    GetStdHandle
        or      eax, eax
        je      init_error
        mov     [console_out], eax

        ret
init_error:
        push    0
        call    ExitProcess
endp


;
  write_console proc    text_out:dword, text_len:dword
;
        pusha
        push    0
        push    offset bytes_read       ; number of bytes read
        push    text_len                ; text length
        push    text_out                ; offset of text
        push    console_out             ; handle
        call    WriteFile
        popa
        ret
endp

;
  write_str_prm proc   text_out:dword, str_disp:dword
;
        pusha
        push    str_disp
        push    text_out
        push    offset text_buff
        call    wsprintfA
        add     esp, 4*3
        push    eax offset text_buff
        call    write_console
        popa
        ret
endp

;
  writeline     proc   text_out:dword
;
        pusha
        push    0
        push    0a0d7325h     ; '%s',0dh,0ah,0
        push    text_out
        lea     eax,[esp+4]
        push    eax
        call    write_str_prm
        add     esp,8
        popa
        ret
endp

